function Uniqueness(arr) {
  return Array.from(new Set(arr));
}

module.exports = function extToRegexp(...input) {
  if (input.length === 0) {
    return undefined;
  }

  const extname = Uniqueness(input);
  const regexp = new RegExp(
    input.length === 1 ? `\\.${input}$` : `\\.(${extname.join('|')})$`
  );
  return Object.freeze(
    Object.defineProperties(regexp, {
      add: {
        value(...ext) {
          return extToRegexp(...extname, ...ext);
        }
      },
      extname: {
        value: Object.freeze(extname)
      }
    })
  );
};
